//-------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//-------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  clrDodgerBlue
#property indicator_color2  clrLightSlateGray
#property indicator_color3  clrSandyBrown
#property indicator_color4  clrSilver
#property indicator_color5  clrDodgerBlue
#property indicator_color6  clrDodgerBlue
#property indicator_color7  clrSandyBrown
#property indicator_color8  clrSandyBrown
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_width7  2
#property indicator_width8  2
#property strict

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased   // Heiken ashi trend biased price
};
enum enColorOn
{
   onZeroCross,  // Change color on middle level cross
   onLevelCross  // Change color on outer levels cross
};
extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT; // Time frame to use
extern int     period            = 25;             // RSX period
extern enPrices price            = pr_close;       // RSX price
extern double  Smooth            = 15;             // Smoothing period for price filter
extern int     minmaxPeriod      = 25;             // Period for floating zero
extern enColorOn ChangeColorOn   = onLevelCross;   // Change colors on :
extern double  upLevel           = 0.90;           // Upper floating level
extern double  downLevel         = 0.10;           // Lower floating level
extern bool    alertsOn          = true;           // Turn alerts on?
extern bool    alertsOnCurrent   = true;           // Alerts on current (still opened) bar?
extern bool    alertsMessage     = true;           // Alerts should show pop-up message?
extern bool    alertsSound       = true;           // Alerts should play alert sound?
extern bool    alertsNotify      = true;           // Alerts should send a push notification?
extern bool    alertsEmail       = true;           // Alerts should send an emil?
extern string  soundFile         = "alert2.wav";   // Sound file to use for alerts
extern bool    Interpolate       = true;           // Interpolate in multi time frame mode?

double rsx[],rsxUa[],rsxUb[],rsxLa[],rsxLb[],DI[],slope[],zero[],up[],down[];
string indicatorFileName;
bool   returnBars;

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(10);
   SetIndexBuffer(0,up);
   SetIndexBuffer(1,zero);
   SetIndexBuffer(2,down);
   SetIndexBuffer(3,rsx);
   SetIndexBuffer(4,rsxUa);
   SetIndexBuffer(5,rsxUb);
   SetIndexBuffer(6,rsxLa);
   SetIndexBuffer(7,rsxLb);
   SetIndexBuffer(8,DI);
   SetIndexBuffer(9,slope);
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame==-99);
         TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" RSX (vhf) adaptive ("+(string)period+")");
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

double wrkBuffer[][14];

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit    = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) {up[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
      if (ArrayRange(wrkBuffer,0)!=Bars) ArrayResize(wrkBuffer,Bars);
      if (slope[limit]==-1) CleanPoint(limit,rsxLa,rsxLb);
      if (slope[limit]== 1) CleanPoint(limit,rsxUa,rsxUb);
      for (int i=limit,r=Bars-i-1; i>=0; i--,r++)
      {
         wrkBuffer[r][13] = getPrice(price,Open,Close,High,Low,i);
         wrkBuffer[r][12] = iSsm(wrkBuffer[r][13],Smooth,i);
         if (i==(Bars-1)) { for (int c=0; c<12; c++) wrkBuffer[r][c] = 0; continue; }  
         
         //
         //
         //
         //
         //
         
         double noise = 0, vhf = 0;
         double max   = wrkBuffer[r][13];
         double min   = wrkBuffer[r][13];
         for (int k=0; k<period && (r-k-1)>=0; k++)
         {
               noise += MathAbs(wrkBuffer[r-k][13]-wrkBuffer[r-k-1][13]);
               max    = MathMax(wrkBuffer[r-k][13],max);   
               min    = MathMin(wrkBuffer[r-k][13],min);   
         }      
         if (noise>0) vhf = (max-min)/noise;
         double rperiod  = period;
         int    fzPeriod = minmaxPeriod;
            if (vhf>0) 
            {
               rperiod  =                       -MathLog(vhf)*period; 
               fzPeriod = (int)MathCeil(MathMax(-MathLog(vhf)*minmaxPeriod,3));
            }               
         double Kg = (3.0)/(2.0+rperiod);
         double Hg = 1.0-Kg;

         //
         //
         //
         //
         //
      
         double roc = wrkBuffer[r][12]-wrkBuffer[r-1][12];
         double roa = MathAbs(roc);
         for (int k=0; k<3; k++)
         {
            int kk = k*2;
               wrkBuffer[r][kk+0] = Kg*roc                + Hg*wrkBuffer[r-1][kk+0];
               wrkBuffer[r][kk+1] = Kg*wrkBuffer[r][kk+0] + Hg*wrkBuffer[r-1][kk+1]; roc = 1.5*wrkBuffer[r][kk+0] - 0.5 * wrkBuffer[r][kk+1];
               wrkBuffer[r][kk+6] = Kg*roa                + Hg*wrkBuffer[r-1][kk+6];
               wrkBuffer[r][kk+7] = Kg*wrkBuffer[r][kk+6] + Hg*wrkBuffer[r-1][kk+7]; roa = 1.5*wrkBuffer[r][kk+6] - 0.5 * wrkBuffer[r][kk+7];
         }
         if (roa != 0)
                rsx[i] = MathMax(MathMin((roc/roa+1.0)*50.0,100.00),0.00); 
         else   rsx[i] = 50.0;
                min   = rsx[ArrayMinimum(rsx,fzPeriod,i)];
                max   = rsx[ArrayMaximum(rsx,fzPeriod,i)];
                double range = max-min;
                  zero[i]  = min+range*0.5;
                  up[i]    = min+range*upLevel;
                  down[i]  = min+range*downLevel;
                  slope[i] = 0;

         if (ChangeColorOn==onLevelCross)
         {
            if (rsx[i]>up[i])   slope[i] =  1;
            if (rsx[i]<down[i]) slope[i] = -1;
         }
         else
         {               
            if (rsx[i]>zero[i]) slope[i] =  1;
            if (rsx[i]<zero[i]) slope[i] = -1;
         }            
         if (slope[i]==-1) PlotPoint(i,rsxLa,rsxLb,rsx);
         if (slope[i]== 1) PlotPoint(i,rsxUa,rsxUb,rsx);
      }
      manageAlerts();
      return(0);
   }   
   
   
   //
   //
   //
   //
   //
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   if (slope[limit]==-1) CleanPoint(limit,rsxLa,rsxLb);
   if (slope[limit]== 1) CleanPoint(limit,rsxUa,rsxUb);
   for(int i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         up[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,period,price,Smooth,minmaxPeriod,ChangeColorOn,upLevel,downLevel,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,0,y);
         zero[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,period,price,Smooth,minmaxPeriod,ChangeColorOn,upLevel,downLevel,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,1,y);
         down[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,period,price,Smooth,minmaxPeriod,ChangeColorOn,upLevel,downLevel,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,2,y);
         rsx[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,period,price,Smooth,minmaxPeriod,ChangeColorOn,upLevel,downLevel,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,3,y);
         slope[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,period,price,Smooth,minmaxPeriod,ChangeColorOn,upLevel,downLevel,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,9,y);
         rsxLa[i] = EMPTY_VALUE;
         rsxLb[i] = EMPTY_VALUE;
         rsxUa[i] = EMPTY_VALUE;
         rsxUb[i] = EMPTY_VALUE;
            if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                  
            //
            //
            //
            //
            //
                  
            int n,k; datetime time = iTime(NULL,TimeFrame,y);
               for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
               for(k = 1; k<n && (i+n)<Bars && (i+k)<Bars; k++) 
               {
                  rsx[i+k]  = rsx[i]  + (rsx[i+n]  - rsx[i] ) * k/n;
                  zero[i+k] = zero[i] + (zero[i+n] - zero[i]) * k/n;
                  up[i+k]   = up[i]   + (up[i+n]   - up[i]  ) * k/n;
                  down[i+k] = down[i] + (down[i+n] - down[i]) * k/n;
               }
   }
   for(int i=limit; i>=0; i--)
   {
      if (slope[i]==-1) PlotPoint(i,rsxLa,rsxLb,rsx);
      if (slope[i]== 1) PlotPoint(i,rsxUa,rsxUb,rsx);
   }      
   return(0);
}  

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

#define Pi 3.14159265358979323846264338327950288
double workSsm[][2];
#define _tprice 0
#define _ssm    1

double workSsmCoeffs[][4];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3

//
//
//
//
//

double iSsm(double tprice, double tperiod, int i, int instanceNo=0)
{
   if (tperiod<=1) return(tprice); i = Bars-i-1;
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_period] != tperiod)
   {
      workSsmCoeffs[instanceNo][_period] = tperiod;
      double a1 = MathExp(-1.414*Pi/tperiod);
      double b1 = 2.0*a1*MathCos(1.414*Pi/tperiod);
         workSsmCoeffs[instanceNo][_c2] = b1;
         workSsmCoeffs[instanceNo][_c3] = -a1*a1;
         workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
   }

   //
   //
   //
   //
   //

      int s = instanceNo*2;   
          workSsm[i][s+_tprice] = tprice;
          if (i>1)
              workSsm[i][s+_ssm]   = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_tprice]+workSsm[i-1][s+_tprice])/2.0 + 
                                     workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm]                                + 
                                     workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm]; 
         else workSsm[i][s+_ssm] = tprice;
   return(workSsm[i][s+_ssm]);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

double workHa[][4];
double getPrice(int tprice, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (tprice>=pr_haclose && tprice<=pr_hatbiased)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars);
         int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (tprice)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (tprice)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
   }
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (slope[whichBar] != slope[whichBar+1])
      {
         if (slope[whichBar] == 1) doAlert(whichBar,"Buy");
         if (slope[whichBar] ==-1) doAlert(whichBar,"Sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," RSX adaptive ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," RSX adaptive " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " RSX adaptive "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}